// MyToolBar.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "MyToolBar.h"
#include "winuser.h"
#include "childfrm.h"

#ifndef MAINFRM_H
	#define MAINFRM_H
	#include "MainFrm.h"
#endif


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyToolBar
//

IMPLEMENT_DYNCREATE(CMyToolBar, CToolBar)

CMyToolBar::CMyToolBar()
{
	m_EditBkBrush.CreateSolidBrush(RGB(192, 192, 192));
	m_idVisible = 0;
}

CMyToolBar::~CMyToolBar()
{
}


BEGIN_MESSAGE_MAP(CMyToolBar, CToolBar)
	//{{AFX_MSG_MAP(CMyToolBar)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CMyToolBar 

void CMyToolBar::OnDestroy() 
{
	CToolBar::OnDestroy();
	
	if(m_Edit.m_hWnd && !m_Edit.DestroyWindow())
		TRACE0(_T("Unable to destroy CEdit at CMyToolBar\n"));
	if(m_Edit1.m_hWnd && !m_Edit1.DestroyWindow())
		TRACE0(_T("Unable to destroy CEdit1 at CMyToolBar\n"));
	if(m_stFrom.m_hWnd && !m_stFrom.DestroyWindow())
		TRACE0(_T("Unable to destroy CStatic (\"From\") at CMyToolBar\n"));
	if(m_stRecord.m_hWnd && !m_stRecord.DestroyWindow())
		TRACE0(_T("Unable to destroy  CStatic (\"Record\")  at CMyToolBar\n"));
}

void CMyToolBar::OnPaint() 
{
	//	05.11.2001 09:26:58		Victor 
	if (m_bDelayedButtonLayout)
		Layout();

	CPaintDC dc(this); // device context for paintin
	DefWindowProc(WM_PAINT,WPARAM(dc.m_hDC),0);

	// Separators hiding
	HideSeparators(&dc);
	// Separators hiding
}

CBrush* CMyToolBar::GetBackgroundBrush()
{
	//	05.11.2001 09:28:40		Victor 
	if(!::IsWindow(GetSafeHwnd()))
		return NULL;

	TCHAR szClassName[1024] = {NULL};

	WNDCLASSEX WndClassEx;
	ZeroMemory(&WndClassEx,sizeof(WndClassEx));
	WndClassEx.cbSize = sizeof(WndClassEx);

	if(::GetClassName(GetSafeHwnd(), 
					  szClassName, 
					  sizeof(szClassName) / sizeof(szClassName[0])) &&
	   ::GetClassInfoEx(::AfxGetApp()->m_hInstance,
						szClassName,
						&WndClassEx))
		return CBrush::FromHandle(WndClassEx.hbrBackground);

	return NULL;
}

void CMyToolBar::HideSeparators(CDC *pDC)
{
	//	05.11.2001 09:29:31		Victor 
	if(!::IsWindow(GetSafeHwnd()))
		return;

	CBrush* pFillBrush = GetBackgroundBrush();
	if(!pFillBrush)
		return;

	CRect ClipBox(0,0,0,0);
	pDC->GetClipBox(ClipBox);
	if(ClipBox.IsRectEmpty())
		return;

	for (HWND hWndChild = ::GetWindow(GetSafeHwnd(), GW_CHILD); hWndChild != NULL; hWndChild = ::GetWindow(hWndChild, GW_HWNDNEXT))
	{
		CRect ChildWindowRect;
		::GetWindowRect(hWndChild,ChildWindowRect);
		ScreenToClient(ChildWindowRect);

		int nToolBarItemCount = GetCount();
		for(int nI=0;nI<nToolBarItemCount;nI++)
		{
			UINT nID = 0;
			UINT nStyle = 0;
			int iImage = 0;

			GetButtonInfo(nI,nID,nStyle,iImage);

			if(nStyle != TBBS_SEPARATOR)
				continue;

			CRect ItemRect;
			GetItemRect(nI,ItemRect);

			if(!CRect().IntersectRect(ChildWindowRect,ItemRect))
				continue;

			CRect FillRect;
			if(!FillRect.IntersectRect(ItemRect,ClipBox))
				continue;

			pDC->FillRect(FillRect,pFillBrush);
		}
	}
}

void CMyToolBar::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//	17.09.2002 18:10:15		Victor
	m_point = point;
	ClientToScreen(&m_point);

	CMainFrame * pChild = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	if(pChild)
	{
	}

	if (m_pDockBar != NULL && OnToolHitTest(point, NULL) == -1)
	{
		// start the drag using CToolBar class
		CToolBar::OnLButtonDown(nFlags, point);
	}
	else
		CWnd::OnLButtonDown(nFlags, point);
}

BOOL CMyToolBar::PreTranslateMessage(MSG *pMsg)
{
	//	30.09.2003 13:50:54		Victor
	//	check only edit controls!
	if(	::IsWindow(m_Edit.GetSafeHwnd()) && ::GetFocus() == m_Edit.GetSafeHwnd() &&
		 pMsg->message == WM_KEYDOWN )
	{
		CString strRecordNo;
		switch(pMsg->wParam)
		{
        case VK_RETURN:
			m_Edit.GetWindowText(strRecordNo);
			if(!strRecordNo.IsEmpty())
			{
				long iRec = _ttol(strRecordNo);
				CMDIChildWnd *pChild = ((CMainFrame*)GetParentFrame())->MDIGetActive();
				if(pChild)
				{
				}
			}
			else
				MessageBeep(0);
			return TRUE;
			break;
		case _T('0'):
		case _T('1'):
		case _T('2'):
		case _T('3'):
		case _T('4'):
		case _T('5'):
		case _T('6'):
		case _T('7'):
		case _T('8'):
		case _T('9'):
		case VK_BACK:
		case VK_LEFT:
		case VK_RIGHT:
			break;
		case VK_DELETE:
			::SendMessage(m_Edit.GetSafeHwnd(), WM_CLEAR, 0, 0);
			break;
		default:
		case VK_ESCAPE:
			return TRUE;
			break;
		}	
	}
	return CToolBar::PreTranslateMessage(pMsg);
}

BOOL CMyToolBar::SetStatusText(int nHit)
{
	return TRUE;
}